/* callbacks.c
 * AbsVolume was programmed by Paul Sherman, derived in near 
 * entirety from the program "volumecontrol" by Rob Eberts
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License v2.
 * source code is available at <http://www.pcbypaul.com>
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "actions.h"

#include <linux/soundcard.h>
#include <stdio.h>                      
#include <fcntl.h>                      
#include <string.h>
#include <stdlib.h>
                     
StereoVolume vol;
extern int mixer_fd;                    
char tmpstring[30];
char tmpstring2[10];
                                        
extern guint status_message_context_id;
extern struct originalset orig;
extern GtkAdjustment *vol_adjustment;

void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  printf("exiting\n");
  gtk_main_quit();
}

void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  printf("exiting\n");
  gtk_main_quit();
}

gboolean
on_spinbutton1_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* main volume */

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton1;
  spin = GTK_SPIN_BUTTON (spinbutton1);
  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);

  return FALSE;
}

gboolean
on_vscale1_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* main volume */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  return FALSE;
}
